/*
 * Example for eINK click with TM21 display
 *
 * Date         Feb 2017
 * Author       MilosV
 * Copyright    GNU Public License v2
 *
 * Test configuration FT90x :
 *  MCU           :        FT900
 *  Dev. Board    :        EasyFT90x
 *  SW            :        mikroC PRO for FT90x v2.2.0
 *
 ******************************************************************************/

#include "eink.h"
#include "image.h"
#include "eink_font.h"

sbit EINK_C_CS      at GPIO_PIN28_bit;
sbit EINK_C_RST     at GPIO_PIN1_bit;
sbit EINK_C_DC      at GPIO_PIN56_bit;
sbit EINK_C_BSY     at GPIO_PIN3_bit;

void sysinit()
{
    GPIO_Digital_Output( &GPIO_PORT_24_31, _GPIO_PINMASK_4 );
    GPIO_Digital_Output( &GPIO_PORT_00_07, _GPIO_PINMASK_1 );
    GPIO_Digital_Output( &GPIO_PORT_56_63, _GPIO_PINMASK_0 );
    GPIO_Digital_Input( &GPIO_PORT_00_07, _GPIO_PINMASK_3 );

    SPIM1_Init_Advanced( _SPI_MASTER_CLK_RATIO_64, _SPI_CFG_PHASE_CAPTURE_RISING |
                         _SPI_CFG_POLARITY_IDLE_HIGH | _SPI_CFG_SS_AUTO_DISABLE |
                         _SPI_CFG_FIFO_DISABLE, _SPI_SS_LINE_NONE );
}

void main()
{
    sysinit();
    eink_init();
    Delay_ms( 1000 );

    while( 1 )
    {
        // Display black letters on white background
        eink_fill_screen( EINK_COLOR_WHITE );
        eink_set_font( guiFont_Exo_2_Condensed21x32_Regular, EINK_COLOR_BLACK, FO_HORIZONTAL );
        eink_text( "EINK", 14, 50 );
        delay_ms( 3000 );

        // Display white letters on black background
        eink_fill_screen( EINK_COLOR_BLACK );
        eink_set_font( guiFont_Exo_2_Condensed21x32_Regular, EINK_COLOR_WHITE, FO_HORIZONTAL );
        eink_text( "EINK", 14, 50 );
        Delay_ms( 3000 );

        // Display external image
        eink_image_bmp( _mikroe_bmp );
        Delay_ms( 3000 );
    }
}